//---------------------------------------------------------------------------
//~Author: Fabio Arciniegas A.
//~Description Get recursive information about namespaces of a DOM node
//
//Version $Id$
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//Header Includes
//---------------------------------------------------------------------------
#include "NamespacesVisitor.h"

//---------------------------------------------------------------------------
// Constructors / Destructors
//---------------------------------------------------------------------------

NamespacesVisitor::NamespacesVisitor(DOM_Node &dom) : myNode(dom)
{
}

/**@name Get Methods
 */
//@{

vector<char *> NamespacesVisitor::getVisibleNamespaces(DOM_Node *node)
{
  if(node == 0)
  {
    node = &myNode;
    ns.erase(ns.begin(),ns.end());
  }

  
  if(node->getNamespaceURI() != 0)
    ns.push_back(node->getNamespaceURI().transcode());

  if(node->getNodeType() == DOM_Node::DOCUMENT_NODE ||
	 node->getParentNode() == 0)
    return ns;
  
  return getVisibleNamespaces(&node->getParentNode());
  
}

char * NamespacesVisitor::getQualifiedName()
{
  if(myNode.getNodeType() != DOM_Node::ELEMENT_NODE)
	return "Not an Element";
  char *result = new char[100];
  strcpy(result,"{");
  
  if(myNode.getNamespaceURI() != 0)
    strcat(result,myNode.getNamespaceURI().transcode());

  strcat(result,"}");
  strcat(result,myNode.getLocalName().transcode());
  
  return result;
}

//@}


