#ifndef StatisticsVisitor_H
#define StatisticsVisitor_H

//---------------------------------------------------------------------------
// Includes and Constants
//---------------------------------------------------------------------------
#include <DOM/DOM.hpp>


//---------------------------------------------------------------------------
// Class definition
//---------------------------------------------------------------------------
/**
   StatisticsVisitor is a visitor class for DOM trees which implements the 
   most common statistics questions about a node, namely: get its name as
   string, count the number of characters that it has (as well as its children)
   and the number of children it has.

   @author Fabio Arciniegas A.
   @version $Id$
 */

class StatisticsVisitor {
 public:
  /**@name Statistic Methods
   */
  //@{

  char *getNodeTypeAsString();
  
  unsigned int getChildrenCount(DOM_Node *node = 0);
  //@}


  /**@name Constructor Methods
   */
  //@{
  StatisticsVisitor(DOM_Node &dom);
  //@}

 private:
  DOM_Node myNode;
};
#endif StatisticsVisitor_H
 

